---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: postgresql
  namespace: legacy
  labels:
    app: databases
    component: postgresql
spec:
  replicas: 1
  selector:
    matchLabels:
      app: databases
      component: postgresql
  template:
    metadata:
      labels:
        app: databases
        component: postgresql
    spec:
      affinity:
        podAffinity:
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchLabels:
                app: databases
                component: postgresql
            topologyKey: kubernetes.io/hostname
      
      containers:
        # - image: busybox
        #   name: prep
        #   volumeMounts:
        #     - name: postgresql-v
        #       mountPath: /mnt/pg-data
        #   command: ["sleep", "99999"]
        #   resources: {}
        - name: postgresql
          image: postgres:15.1
          args:
          - -c
          - shared_buffers=256MB
          - -c
          - max_connections=300
          ports:
            - name: postgresql
              containerPort: 5432
          env:
            - name: "POSTGRES_PASSWORD"
              value: "test"
            - name: "POSTGRES_USER"
              value: "postgres"
          volumeMounts:
            - {"name":"postgresql-v","mountPath":"/var/lib/postgresql/data/"}
          resources: {}
      volumes:
        - {"persistentVolumeClaim":{"claimName":"postgresql-pvc"},"name":"postgresql-v"}

# ---
# apiVersion: v1
# kind: Service
# metadata:
#   name: postgresql-np
#   labels:
#     name: postgresql
#     owner: agepinfo
# spec:
#   ports:
#     - port: 5432
#       targetPort: 5432
#       nodePort: 32700
#       name: postgresql
#   selector:
#       app: postgresql
#       owner: agepinfo
#   type: NodePort

---
kind: PersistentVolumeClaim
apiVersion: v1
metadata:
  name: postgresql-pvc
  namespace: legacy
spec:
  storageClassName: ssd-r3
  accessModes:
    - ReadWriteOnce
  resources:
    requests:
      storage: 5G

---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: mariadb
  namespace: legacy
  labels:
    app: databases
    component: mariadb
spec:
  replicas: 1
  selector:
    matchLabels:
      app: databases
      component: mariadb
  template:
    metadata:
      labels:
        app: databases
        component: mariadb
    spec:
      affinity:
        podAffinity:
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchLabels:
                app: databases
                component: mariadb
            topologyKey: kubernetes.io/hostname
      
      containers:
        - name: mariadb
          image: mariadb:10.3.18
          # args:
          # - --skip-grant-tables # disable authorization mechanism
          
          ports:
            - name: mariadb
              containerPort: 3306
          env:
            - name: "MYSQL_ROOT_PASSWORD"
              value: "test"
          volumeMounts:
            - {"name":"mariadb-v","mountPath":"/var/lib/mysql/"}
          resources: {}
        # - image: busybox
        #   name: prep
        #   volumeMounts:
        #     - name: mariadb-v
        #       mountPath: /mnt/mysql
        #   command: ["sleep", "99999"]
        #   resources: {}
      volumes:
        - {"persistentVolumeClaim":{"claimName":"mariadb-pvc"},"name":"mariadb-v"}

# ---
# apiVersion: v1
# kind: Service
# metadata:
#   name: mariadb-np
#   labels:
#     name: mariadb
#     owner: agepinfo
# spec:
#   ports:
#     - port: 3306
#       targetPort: 3306
#       nodePort: 32701
#       name: mariadb
#   selector:
#       app: databases
#       owner: agepinfo
#   type: NodePort

---
kind: PersistentVolumeClaim
apiVersion: v1
metadata:
  name: mariadb-pvc
  namespace: legacy
spec:
  accessModes:
    - ReadWriteOnce
  storageClassName: ssd-r3
  resources:
    requests:
      storage: 6Gi

---
apiVersion: v1
kind: Service
metadata:
  name: databases
  namespace: legacy
  labels:
    app: databases
spec:
  ports:
  - name: mariadb
    port: 3306
    protocol: TCP
    targetPort: mariadb
  - name: postgresql
    port: 5432
    protocol: TCP
    targetPort: postgresql
  selector:
      app: databases  
  sessionAffinity: None
  type: ClusterIP